/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mouse Gesture for Mozilla.
 *
 * The Initial Developer of the Original Code is Pavol Vaskovic.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Edmonds <aedmonds@mindspring.com> 
 *  Ben Williams <benw@webmedia.com.au>
 *  Benjamin K. Stuhl <tiriath@yahoo.com>
 *  Jeremy Wrinkle (Exotrip)        FIXME  email
 *  Pavol Vaskovic <pali@pali.sk>
 *  Scurrie                         FIXME whole name, email
 *  Steve Kangas <bookmarklets.com> FIXME  email
 *  Squarefree.com                  FIXME who exactly: whole name, email
 *  David Illsley <illsleydc@bigfoot.com>
 *  Jens Bannmann <jens.b@web.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function mgB_Back() {
  BrowserBack(); // mozilla function
  resetRocker();
  return "mgB_Back";
}

function mgB_Forward() {
  BrowserForward(); // mozilla function
  resetRocker();
  return "mgB_Forward";
}

function mgB_Reload() {
  BrowserReload(); // mozilla function
  resetRocker();
  return "mgB_Reload";
}

function mgB_ReloadFrame() {
  globalSrcEvent.target.ownerDocument.location.reload();
  resetRocker();
  return "mgB_ReloadFrame";
}

function mgB_ReloadSkipCache() {
  BrowserReloadSkipCache(); // mozilla function
  resetRocker();
  return "mgB_ReloadSkipCache";
}

function mgB_Stop() {
  BrowserStop(); // mozilla function
  return "mgB_Stop";
}

function mgB_Home() {
  BrowserHome(); // mozilla function
  resetRocker();
  return "mgB_Home";
}

function mgB_ZoomIn_DoubleImage() {
  if (globalOnImage) {
    return mgB_DoubleImageSize();
  } else {
    return mgB_ZoomIn();
  }
}

function mgB_ZoomOut_HalveImage() {
  if (globalOnImage) {
    return mgB_HalveImageSize();
  } else {
    return mgB_ZoomOut();
  }
}

function mgB_ResetZoom_HideImage() {
  if (globalOnImage) {
    return mgB_HideImage();
  } else {
    return mgB_ResetZoom();
  }
}

function mgB_ZoomIn() {
  ZoomManager.prototype.getInstance().enlarge();
  return "mgB_ZoomIn";
}

function mgB_ZoomOut() {
  ZoomManager.prototype.getInstance().reduce();
  return "mgB_ZoomOut";
}

function mgB_ResetZoom() {
  ZoomManager.prototype.getInstance().reset();
  return "mgB_ResetZoom";
}

function mgB_HalveImageSize() {
  setImageSize(.5);
  return "mgB_HalveImageSize";
}

function mgB_DoubleImageSize() {
  setImageSize(2);
  return "mgB_DoubleImageSize";
}

function mgB_HideImage() {
  setImageSize(0);
  return "mgB_HideImage";
}

function setImageSize(aSize) {
  if(globalOnImage) {
    var w = globalOnImage.width;
    var h = globalOnImage.height; 
    globalOnImage.style.width = (w * aSize) + "px";
    globalOnImage.style.height = (h * aSize) + "px";
  }
}

function mgB_OpenTab() {
  return openTab(true);
}

function mgB_OpenBlankOrLinkTab() {
  return openTab(false);
}

function openTab(bUseSel) {
  if(globalOnLink) {
    linkInTab(globalOnLink[0].href);
    markLinkVisited(globalOnLink[0]);
  } else {
    var sel = getSelection().toString();
    if (bUseSel && sel.match(/^(http)|(ftp):/)) {
      linkInTab(sel);
    } else {
      BrowserOpenTab(); // mozilla function
    }
  }
  return "mgB_OpenTab";
}

function getSelection() {
  return globalSrcEvent.view.getSelection();
}

function mgB_DuplicateTab() {
  linkInTab(window._content.document.location);
  return "mgB_DuplicateTab";
}

function linkInTab(url){
  var browser = getBrowser();
  var tab = browser.addTab(url, getReferrer(document));
  if (!prefRoot.getBoolPref("browser.tabs.loadInBackground"))
    browser.selectedTab = tab;
}

function mgB_LinksInTabs(){
  var browser = getBrowser();
  for(i = 0; i < globalOnLink.length; i++) {
    tab = browser.addTab(globalOnLink[i].href, getReferrer(document));
    markLinkVisited(globalOnLink[i]);
  }
  return "mgB_LinksInTabs";
}

function mgB_NextTab() {
  getBrowser().mTabBox._tabs.advanceSelectedTab(+1);
  return "mgB_NextTab";
}

function mgB_PreviousTab() {
  getBrowser().mTabBox._tabs.advanceSelectedTab(-1);
  return "mgB_PreviousTab";
}

function mgB_ViewPageSource() {
  BrowserViewSourceOfDocument(content.document);
  return "mgB_ViewPageSource";
}

function mgB_ViewFrameSource() {
  BrowserViewSourceOfDocument(globalSrcEvent.originalTarget.ownerDocument);
  return "mgB_ViewFrameSource";
}

function mgB_ViewFrameOrPartialSource() {
  return mgB_ViewPartialSource() || mgB_ViewFrameSource();
}

function mgB_ViewPartialSource() {
  if (getSelection().toString() != "") {
    window.setTimeout(viewPartialSourceImpl, 10);
    return "mgB_ViewPartialSource";
  } else {
    return false;
  }
}

function viewPartialSourceImpl() {
    var focusedWindow = document.commandDispatcher.focusedWindow;
    if (focusedWindow == window)
      focusedWindow = _content;
    var docCharset = null;
    if (focusedWindow)
      docCharset = "charset=" + focusedWindow.document.characterSet;

    reference = focusedWindow.__proto__.getSelection.call(focusedWindow);
    
    var docUrl = null;
    window.openDialog("chrome://navigator/content/viewPartialSource.xul",
                      "_blank", "scrollbars,resizable,chrome,dialog=no",
                      docUrl, docCharset, reference, "selection");
}

function newBrowserWindow() {
  window.open();
  return kWindowMediator.getMostRecentWindow("navigator:browser");
}

function mgB_LinksInWindows(){
  for(i = 0; i < globalOnLink.length; i++) {
    newBrowserWindow().loadURI(globalOnLink[i].href, getReferrer(document));
    markLinkVisited(globalOnLink[i]);
  }
  return "mgB_LinksInWindows";
}

function mgB_OpenNewDocument(){
  if(globalOnLink) { // open link in new window
    newBrowserWindow().loadURI(globalOnLink[0].href, getReferrer(document));
    markLinkVisited(globalOnLink[0]);
  } else {
    if (globalOnImage) {     // Open image in new window
      window.open(globalOnImage);
    } else { // open blank window
      newBrowserWindow().loadURI(
          (prefRoot.getIntPref("browser.startup.page") == 1) ? getHomePage()
                                                             : "",
          getReferrer(document));
    }
  }
  return "mgB_OpenNewDocument";
}

function mgB_DuplicateWindow(){
  newBrowserWindow().loadURI(window._content.document.location,
      getReferrer(document));
  return "mgB_DuplicateWindow";
}

function mgB_AddBookmark() {
  addBookmarkAs(document.getElementById('content'));
  return "mgB_AddBookmark";
}

function mgB_CloseDoc() {
  BrowserCloseTabOrWindow();
  return "mgB_CloseDoc";
}

function mgB_ScrollDown() {
  globalSrcEvent.view.scrollBy(0,200);
  return "mgB_ScrollDown";
}

function mgB_ScrollUp() {
  globalSrcEvent.view.scrollBy(0,-200);
  return "mgB_ScrollUp";
}

function mgB_UpDir(){ //from bookmarklets.com
  var aUrl = window._content.document.location.href;
  if (window._content.document.location.protocol != "about:")
    aUrl = aUrl.substring(0, aUrl.substring(0, aUrl.length-1).lastIndexOf('/')+1);
    window._content.document.location.href = aUrl;
  return "mgB_UpDir";
}

function mgB_ViewSiteCookies(){ //Contributed by Squarefree.com
  if (window._content.document.cookie)
    alert(bundle.getString("cookies") + "\n\n"
      + window._content.document.cookie.replace(/; /g,"\n"));
  else alert(bundle.getString("noCookies"));
  return "mgB_ViewSiteCookies";
}

function mgB_MetaInfo(){
  var metas = window._content.document.getElementsByTagName("meta");
  if (metas.length != 0){
    var metastr = bundle.getString("meta") + "\n\n";
    for(var ameta = 0; ameta < metas.length; ameta++) {
      var mymeta = metas.item(ameta);
      metastr += "<META ";
      if (mymeta.name) metastr += "name=\"" + mymeta.name + "\" ";
      if (mymeta.httpEquiv) metastr+= "http-equiv=\"" + mymeta.httpEquiv + "\" ";
      if (mymeta.content) metastr += "content=\"" + mymeta.content + "\" ";
      if (mymeta.scheme) metastr += "scheme=\"" + mymeta.scheme + "\" ";
      metastr += '>\n';
    }
    alert(metastr);
  }
  else alert(bundle.getString("noMeta"));
  return "mgB_MetaInfo";
}

function mgB_ViewPageInfo() {
  BrowserPageInfo();
  return "mgB_ViewPageInfo";
}

function mgB_ViewFrameInfo() {
  BrowserPageInfo(globalSrcEvent.target.ownerDocument);
  return "mgB_ViewFrameInfo";
}

function mgB_DoubleStackWin(){
  var tempW;
  if(globalOnLink) { 
    window.moveTo(0,0);
    window.resizeTo(screen.availWidth/2, screen.availHeight);
    tempW = newBrowserWindow();
    tempW.loadURI(globalOnLink[0].href, getReferrer(document));
    tempW.moveTo(screen.availWidth/2 + 1, 0);
    tempW.resizeTo(screen.availWidth/2,screen.availHeight);
    markLinkVisited(globalOnLink[0]);
  }
  return "mgB_DoubleStackWin";
}

function mgB_W3cValidate() {
  window._content.document.location='http://validator.w3.org/check?uri='+window._content.document.location;
  return "mgB_W3cValidate";
}

/*** PRINT PREVIEW FUNCTIONS ***/

function mgBP_ExitPrintPreview() {
  if (document.getElementById("print-preview-toolbar") != null) {
    window.setTimeout(BrowserExitPrintPreview, 100); // mozilla function
    return "mgBP_ExitPrintPreview";
  }
}
