mgMappingLocalizer = {
  dict : null,
  reverse : null,
  bundle : null,

  init : function() {
    // initialize localization dictionary
    var srv = Components.classes["@mozilla.org/intl/stringbundle;1"].getService()
              .QueryInterface(Components.interfaces.nsIStringBundleService);
    this.bundle = srv.createBundle("chrome://mozgest/locale/mozgest.properties");

    this.dict = new Array();
    this.dict["R"] = this.bundle.GetStringFromName("abbreviation.right");
    this.dict["L"] = this.bundle.GetStringFromName("abbreviation.left");
    this.dict["U"] = this.bundle.GetStringFromName("abbreviation.up");
    this.dict["D"] = this.bundle.GetStringFromName("abbreviation.down");
    this.dict["1"] = this.bundle.GetStringFromName("abbreviation.d1");
    this.dict["3"] = this.bundle.GetStringFromName("abbreviation.d3");
    this.dict["7"] = this.bundle.GetStringFromName("abbreviation.d7");
    this.dict["9"] = this.bundle.GetStringFromName("abbreviation.d9");

    this.reverse = new Array();
    for (var loc in this.dict) {
      this.reverse[this.dict[loc]] = loc;
    }
  },

  localize : function(orig) {
    if(!this.dict) this.init();
    return this.convert(orig, this.dict);
  },

  deLocalize : function(localized) {
    if(!this.dict) this.init();
    return this.convert(localized, this.reverse);
  },

  convert : function(str, table) {
    if (!str) return "";
    var trans = "";
    for (var i = 0; i < str.length; i++) {
      var o = str.substring(i, i+1);
      if(table[o]) {
        trans = trans + table[o];
      } else {
        trans = trans + o;
      }
    }
    return trans;
  },

  parseRDF : function(property, target) {
    if (!target) return target;
    if (property.Value == mgStorage.NS + "code") {
      var orig = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      locNode = mgStorage.RDF.GetLiteral(this.localize(orig));
      return locNode;
    } else {
      return target;
    }
  },

  getString : function(aName) {
    if(!this.bundle) this.init();
    return this.bundle.GetStringFromName(aName);
  },
}
