// Search Button Lite 0.2
// By Pike

var SearchButtonLiteSettings = {

	prefService: null,
	leftButton: null,
	middleButton: null,
	rightButton: null,
	enterKey: null,
	autoClear: null,
	
	onLoad: function()
	{
		// Setup object properties
		this.prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('searchbuttonlite.');
		this.leftButton = document.getElementById('left-button');
		this.middleButton = document.getElementById('middle-button');
		this.rightButton = document.getElementById('right-button');
		this.enterKey = document.getElementById('enter-key');
		this.autoClear = document.getElementById('auto-clear');
		
		var leftButtonPref = 5;
		try
		{
			leftButtonPref = this.prefService.getIntPref('left_button');
		}
		catch (err) {}
		this.leftButton.selectedIndex = leftButtonPref;
		
		var middleButtonPref = 2;
		try
		{
			middleButtonPref = this.prefService.getIntPref('middle_button');
		}
		catch (err) {}
		this.middleButton.selectedIndex = middleButtonPref;
		
		var rightButtonPref = 1;
		try
		{
			rightButtonPref = this.prefService.getIntPref('right_button');
		}
		catch (err) {}
		this.rightButton.selectedIndex = rightButtonPref;
		
		var enterKeyPref = 1;
		try
		{
			enterKeyPref = this.prefService.getIntPref('enter_key');
		}
		catch (err) {}
		this.enterKey.selectedIndex = enterKeyPref;
		
		var autoClearPref = false;
		try
		{
			autoClearPref = this.prefService.getBoolPref('auto_clear');
		}
		catch (err) {}
		this.autoClear.checked = autoClearPref;
	},
	
	onAccept: function()
	{
		this.prefService.setIntPref('left_button', this.leftButton.selectedIndex);
		this.prefService.setIntPref('middle_button', this.middleButton.selectedIndex);
		this.prefService.setIntPref('right_button', this.rightButton.selectedIndex);
		this.prefService.setIntPref('enter_key', this.enterKey.selectedIndex);
		this.prefService.setBoolPref('auto_clear', this.autoClear.checked);
	}
};
